#include "StdAfx.h"
#include "Mesh.h"
#include "Utils.h"
#include <sstream>
#include <boost/shared_ptr.hpp>

using namespace boost;
using namespace std;

CMesh::CMesh(void)
{
}

CMesh::~CMesh(void)
{
}

WORD CMesh::AddVert( const VertPosNormalTc& vert )
{
	// ,       
	const size_t count = m_vecVerts.size();
	for (size_t i=0; i<count; i++)
		if (vert == m_vecVerts[i])
			return (WORD)i; // ,  
	
	//   - 
	m_vecVerts.push_back(vert);
	return (WORD)(m_vecVerts.size()-1);
}

void CMesh::AddFaceVert( const VertPosNormalTc& vert )
{
	//      
	const WORD idx = AddVert(vert);
	//     
	m_vecFaces.push_back(idx);
}

bool CMesh::Load( const std::string& strFileName )
{
	std::string contents = GetFileAsString(strFileName);
	if (contents.length()==0)
		return false;

	//    ""
	std::stringstream ss(contents);

	//   ,   . 
	int iNumVerts, iNumFaces, iNumTVerts;
	ss>>iNumVerts>>iNumFaces>>iNumTVerts;

	vector<D3DXVECTOR3> vecPos;
	vector<D3DXVECTOR3> vecNormal;
	//     
	//     
	vecPos.resize(iNumVerts);
	vecNormal.resize(iNumVerts);
	for (int i=0; i<iNumVerts; i++)
	{
		//  
		ss>>vecPos[i].x>>vecPos[i].y>>vecPos[i].z;
		//  
		ss>>vecNormal[i].x>>vecNormal[i].y>>vecNormal[i].z;
	}
	vector<D3DXVECTOR3> vecTc;
	vecTc.resize(iNumTVerts);
	//   
	//         (UV)
	//       -  
	for (int i=0; i<iNumTVerts; i++)
		ss>>vecTc[i].x>>vecTc[i].y>>vecTc[i].z;

	vector<WORD> vecFace;
	vector<WORD> vecFaceTc;
	//  
	//      
	vecFace.resize(iNumFaces*3);
	vecFaceTc.resize(iNumFaces*3);
	for (int i=0; i<iNumFaces*3; i+=3)
	{
		//  
		ss>>vecFace[i]>>vecFace[i+1]>>vecFace[i+2];
		ss>>vecFaceTc[i]>>vecFaceTc[i+1]>>vecFaceTc[i+2];
		//  3d max    
		//   C++  .     1
		vecFace[i]--;	vecFace[i+1]--;	vecFace[i+2]--;
		vecFaceTc[i]--;	vecFaceTc[i+1]--;	vecFaceTc[i+2]--;
	}

	//       
	for (int i=0; i<iNumFaces*3; i++)
	{
		VertPosNormalTc vert;
		//  
		vert.m_pos = vecPos[ vecFace[i] ];
		vert.m_normal = vecNormal[ vecFace[i] ];
		D3DXVECTOR3 tc = vecTc[ vecFaceTc[i] ];
		vert.m_tc = D3DXVECTOR2(tc.x, tc.y);
		//  
		AddFaceVert(vert);
	}
	return true;
}
